Index: trunk/FACT++/gui/RawEventsViewer/viewer.ui
===================================================================
--- trunk/FACT++/gui/RawEventsViewer/viewer.ui	(revision 11614)
+++ trunk/FACT++/gui/RawEventsViewer/viewer.ui	(revision 11697)
@@ -7,6 +7,6 @@
     <x>0</x>
     <y>0</y>
-    <width>1125</width>
-    <height>928</height>
+    <width>1133</width>
+    <height>1017</height>
    </rect>
   </property>
@@ -16,5 +16,5 @@
   <widget class="QWidget" name="centralwidget">
    <layout class="QGridLayout" name="gridLayout_2">
-    <item row="0" column="0">
+    <item row="0" column="1">
      <layout class="QHBoxLayout" name="horizontalLayout_2" stretch="10,0">
       <item>
@@ -24,10 +24,187 @@
         </property>
         <item>
-         <widget class="RawDataViewer" name="GLWindow" native="true"/>
+         <widget class="QTabWidget" name="tabWidget_2">
+          <property name="sizePolicy">
+           <sizepolicy hsizetype="Preferred" vsizetype="Preferred">
+            <horstretch>0</horstretch>
+            <verstretch>0</verstretch>
+           </sizepolicy>
+          </property>
+          <property name="currentIndex">
+           <number>0</number>
+          </property>
+          <widget class="QWidget" name="tab_5">
+           <property name="layoutDirection">
+            <enum>Qt::LeftToRight</enum>
+           </property>
+           <attribute name="title">
+            <string>Camera View</string>
+           </attribute>
+           <layout class="QGridLayout" name="gridLayout_3">
+            <item row="0" column="0">
+             <widget class="RawDataViewer" name="GLWindow" native="true">
+              <property name="enabled">
+               <bool>true</bool>
+              </property>
+              <property name="sizePolicy">
+               <sizepolicy hsizetype="Maximum" vsizetype="Maximum">
+                <horstretch>0</horstretch>
+                <verstretch>0</verstretch>
+               </sizepolicy>
+              </property>
+              <property name="maximumSize">
+               <size>
+                <width>10000</width>
+                <height>10000</height>
+               </size>
+              </property>
+             </widget>
+            </item>
+           </layout>
+          </widget>
+          <widget class="QWidget" name="tab_6">
+           <property name="sizePolicy">
+            <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+             <horstretch>0</horstretch>
+             <verstretch>0</verstretch>
+            </sizepolicy>
+           </property>
+           <attribute name="title">
+            <string>Data View</string>
+           </attribute>
+           <layout class="QVBoxLayout" name="verticalLayout_2">
+            <item>
+             <widget class="QTabWidget" name="tabWidget_3">
+              <property name="sizePolicy">
+               <sizepolicy hsizetype="Preferred" vsizetype="Preferred">
+                <horstretch>1</horstretch>
+                <verstretch>1</verstretch>
+               </sizepolicy>
+              </property>
+              <property name="tabShape">
+               <enum>QTabWidget::Rounded</enum>
+              </property>
+              <property name="currentIndex">
+               <number>1</number>
+              </property>
+              <property name="elideMode">
+               <enum>Qt::ElideNone</enum>
+              </property>
+              <widget class="QWidget" name="tab_3">
+               <property name="sizePolicy">
+                <sizepolicy hsizetype="Preferred" vsizetype="Preferred">
+                 <horstretch>0</horstretch>
+                 <verstretch>0</verstretch>
+                </sizepolicy>
+               </property>
+               <attribute name="title">
+                <string>Arrays data</string>
+               </attribute>
+               <layout class="QVBoxLayout" name="verticalLayout_6">
+                <item>
+                 <widget class="QLabel" name="label_3">
+                  <property name="text">
+                   <string>Boards time values</string>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QListWidget" name="boardsTimeList">
+                  <property name="font">
+                   <font>
+                    <family>FreeMono</family>
+                   </font>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QLabel" name="label_13">
+                  <property name="text">
+                   <string>Start Cells</string>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QListWidget" name="startPixelsList">
+                  <property name="font">
+                   <font>
+                    <family>FreeMono</family>
+                   </font>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QLabel" name="StartTimeMarksList">
+                  <property name="text">
+                   <string>Start Time Marks</string>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QListWidget" name="startTimeMarksList">
+                  <property name="sizePolicy">
+                   <sizepolicy hsizetype="Preferred" vsizetype="Preferred">
+                    <horstretch>0</horstretch>
+                    <verstretch>0</verstretch>
+                   </sizepolicy>
+                  </property>
+                  <property name="font">
+                   <font>
+                    <family>FreeMono</family>
+                   </font>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QLabel" name="label_4">
+                  <property name="text">
+                   <string>Trigger Delays</string>
+                  </property>
+                 </widget>
+                </item>
+                <item>
+                 <widget class="QListWidget" name="triggerDelayList"/>
+                </item>
+               </layout>
+              </widget>
+              <widget class="QWidget" name="tab_4">
+               <attribute name="title">
+                <string>Histograms</string>
+               </attribute>
+               <layout class="QVBoxLayout" name="verticalLayout_3">
+                <item>
+                 <widget class="QwtPlot" name="boardsTimeHisto"/>
+                </item>
+                <item>
+                 <widget class="QwtPlot" name="startCellsHisto"/>
+                </item>
+                <item>
+                 <widget class="QwtPlot" name="startTimeMarkHisto"/>
+                </item>
+                <item>
+                 <widget class="QwtPlot" name="triggerDelayHisto"/>
+                </item>
+               </layout>
+              </widget>
+              <widget class="QWidget" name="tab">
+               <attribute name="title">
+                <string>Pixel Curves</string>
+               </attribute>
+               <layout class="QGridLayout" name="gridLayout_4">
+                <item row="0" column="0">
+                 <widget class="QwtPlot" name="pixelValueCurve"/>
+                </item>
+               </layout>
+              </widget>
+             </widget>
+            </item>
+           </layout>
+          </widget>
+         </widget>
         </item>
        </layout>
       </item>
       <item>
-       <layout class="QVBoxLayout" name="verticalLayout" stretch="0,0,0,0,0,0,0,0,0,0,0">
+       <layout class="QVBoxLayout" name="verticalLayout" stretch="0,0,0,0">
         <property name="sizeConstraint">
          <enum>QLayout::SetDefaultConstraint</enum>
@@ -36,57 +213,33 @@
          <widget class="QLabel" name="label">
           <property name="text">
-           <string>FACT - Raw events viewer - v0.1</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="fileLoadedLabel">
+           <string>FACT - Raw events viewer - v0.2</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QLabel" name="extraInfoLabel">
           <property name="text">
-           <string>File loaded: none</string>
-          </property>
-          <property name="wordWrap">
-           <bool>true</bool>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="runNumberLabel">
-          <property name="text">
-           <string>Run number:</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="numberOfSlicesLabel">
-          <property name="text">
-           <string>Number of Events/Slices:</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="numberOfTimeMarksLabel">
-          <property name="text">
-           <string>Number of Time Marks:</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="runTypeLabel">
-          <property name="text">
-           <string>Run Type:</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="timeOfFirstDataLabel">
-          <property name="text">
-           <string>Time of 1st data:</string>
-          </property>
-         </widget>
-        </item>
-        <item>
-         <widget class="QLabel" name="timeOfLastDataLabel">
-          <property name="text">
-           <string>Time of last data:</string>
+           <string>File loaded: none
+Run number:
+Number of Events:
+Number ofSlices:
+Number of Time Marks:
+Run Type:
+Time of 1st data:
+Time of last data:
+SVN revision:
+Number of boards:
+Number of pixels:
+Number of Slices TM:
+Time system:
+Date:
+Night:
+Camera:
+DAQ:
+ADC Count:
+NB Evts OK:
+NB Evts Rejected:
+NB Evts Bad:
+</string>
           </property>
          </widget>
@@ -95,5 +248,5 @@
          <layout class="QVBoxLayout" name="verticalLayout_5">
           <item>
-           <widget class="QLabel" name="label_8">
+           <widget class="QLabel" name="label_5">
             <property name="font">
              <font>
@@ -104,5 +257,5 @@
             </property>
             <property name="text">
-             <string>Arrays data</string>
+             <string>Selected Pixel</string>
             </property>
             <property name="alignment">
@@ -112,50 +265,102 @@
           </item>
           <item>
-           <widget class="QLabel" name="label_9">
-            <property name="text">
-             <string>Boards times</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QListWidget" name="boardsTimeList">
-            <property name="font">
-             <font>
-              <family>FreeMono</family>
-             </font>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QLabel" name="label_13">
-            <property name="text">
-             <string>Start Pixels</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QListWidget" name="startPixelsList">
-            <property name="font">
-             <font>
-              <family>FreeMono</family>
-             </font>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QLabel" name="StartTimeMarksList">
-            <property name="text">
-             <string>Start Time Marks</string>
-            </property>
-           </widget>
-          </item>
-          <item>
-           <widget class="QListWidget" name="startTimeMarksList">
-            <property name="font">
-             <font>
-              <family>FreeMono</family>
-             </font>
-            </property>
-           </widget>
+           <layout class="QHBoxLayout" name="horizontalLayout_6">
+            <item>
+             <widget class="QLabel" name="label_10">
+              <property name="text">
+               <string>Hardware ID</string>
+              </property>
+              <property name="alignment">
+               <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+              </property>
+             </widget>
+            </item>
+            <item>
+             <widget class="QSpinBox" name="HwIDBox">
+              <property name="maximum">
+               <number>10000</number>
+              </property>
+              <property name="value">
+               <number>393</number>
+              </property>
+             </widget>
+            </item>
+           </layout>
+          </item>
+          <item>
+           <layout class="QHBoxLayout" name="horizontalLayout_7">
+            <item>
+             <widget class="QLabel" name="label_11">
+              <property name="text">
+               <string>Software ID</string>
+              </property>
+              <property name="alignment">
+               <set>Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter</set>
+              </property>
+             </widget>
+            </item>
+            <item>
+             <widget class="QSpinBox" name="SwIDBox">
+              <property name="maximum">
+               <number>1440</number>
+              </property>
+             </widget>
+            </item>
+           </layout>
+          </item>
+          <item>
+           <layout class="QGridLayout" name="gridLayout_5">
+            <item row="2" column="0">
+             <widget class="QLabel" name="label_6">
+              <property name="text">
+               <string>Crate</string>
+              </property>
+             </widget>
+            </item>
+            <item row="2" column="1">
+             <widget class="QLabel" name="label_8">
+              <property name="text">
+               <string>Board</string>
+              </property>
+             </widget>
+            </item>
+            <item row="2" column="2">
+             <widget class="QLabel" name="label_9">
+              <property name="text">
+               <string>Patch</string>
+              </property>
+             </widget>
+            </item>
+            <item row="3" column="0">
+             <widget class="QSpinBox" name="crateIDBox">
+              <property name="maximum">
+               <number>39</number>
+              </property>
+              <property name="value">
+               <number>9</number>
+              </property>
+             </widget>
+            </item>
+            <item row="3" column="1">
+             <widget class="QSpinBox" name="boardIDBox">
+              <property name="maximum">
+               <number>9</number>
+              </property>
+              <property name="value">
+               <number>8</number>
+              </property>
+             </widget>
+            </item>
+            <item row="3" column="2">
+             <widget class="QSpinBox" name="patchIDBox">
+              <property name="maximum">
+               <number>3</number>
+              </property>
+              <property name="value">
+               <number>1</number>
+              </property>
+             </widget>
+            </item>
+           </layout>
           </item>
          </layout>
@@ -198,4 +403,11 @@
           </item>
           <item>
+           <widget class="QLabel" name="currentPixelValue">
+            <property name="text">
+             <string>Current Pixel val.:</string>
+            </property>
+           </widget>
+          </item>
+          <item>
            <widget class="QLabel" name="triggerTypeLabel">
             <property name="text">
@@ -220,24 +432,21 @@
          </layout>
         </item>
-        <item>
-         <layout class="QVBoxLayout" name="verticalLayout_3"/>
-        </item>
        </layout>
       </item>
      </layout>
     </item>
-    <item row="1" column="0">
+    <item row="1" column="1">
      <layout class="QGridLayout" name="gridLayout">
-      <item row="0" column="6">
+      <item row="0" column="7">
        <widget class="QDoubleSpinBox" name="colorRange4">
         <property name="enabled">
-         <bool>false</bool>
-        </property>
-        <property name="decimals">
-         <number>3</number>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="6">
+         <bool>true</bool>
+        </property>
+        <property name="decimals">
+         <number>3</number>
+        </property>
+       </widget>
+      </item>
+      <item row="2" column="7">
        <widget class="QDoubleSpinBox" name="greenValue4">
         <property name="decimals">
@@ -246,41 +455,44 @@
        </widget>
       </item>
+      <item row="1" column="7">
+       <widget class="QDoubleSpinBox" name="redValue4">
+        <property name="decimals">
+         <number>3</number>
+        </property>
+       </widget>
+      </item>
+      <item row="3" column="7">
+       <widget class="QDoubleSpinBox" name="blueValue4">
+        <property name="decimals">
+         <number>3</number>
+        </property>
+       </widget>
+      </item>
       <item row="1" column="6">
-       <widget class="QDoubleSpinBox" name="redValue4">
-        <property name="decimals">
-         <number>3</number>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="7">
-       <widget class="QPushButton" name="playPauseButton">
-        <property name="text">
-         <string>Play/Pause</string>
-        </property>
-       </widget>
-      </item>
-      <item row="3" column="6">
-       <widget class="QDoubleSpinBox" name="blueValue4">
-        <property name="decimals">
-         <number>3</number>
+       <widget class="QDoubleSpinBox" name="redValue3">
+        <property name="decimals">
+         <number>3</number>
+        </property>
+       </widget>
+      </item>
+      <item row="0" column="8">
+       <widget class="QPushButton" name="loadNewFileButton">
+        <property name="toolTip">
+         <string>Load a new fits file</string>
+        </property>
+        <property name="text">
+         <string>Load New File</string>
         </property>
        </widget>
       </item>
       <item row="1" column="5">
-       <widget class="QDoubleSpinBox" name="redValue3">
-        <property name="decimals">
-         <number>3</number>
-        </property>
-       </widget>
-      </item>
-      <item row="0" column="7">
-       <widget class="QPushButton" name="loadNewFileButton">
-        <property name="text">
-         <string>Load New File</string>
+       <widget class="QDoubleSpinBox" name="redValue2">
+        <property name="decimals">
+         <number>3</number>
         </property>
        </widget>
       </item>
       <item row="1" column="4">
-       <widget class="QDoubleSpinBox" name="redValue2">
+       <widget class="QDoubleSpinBox" name="redValue1">
         <property name="decimals">
          <number>3</number>
@@ -289,5 +501,5 @@
       </item>
       <item row="1" column="3">
-       <widget class="QDoubleSpinBox" name="redValue1">
+       <widget class="QDoubleSpinBox" name="redValue0">
         <property name="decimals">
          <number>3</number>
@@ -296,11 +508,4 @@
       </item>
       <item row="1" column="2">
-       <widget class="QDoubleSpinBox" name="redValue0">
-        <property name="decimals">
-         <number>3</number>
-        </property>
-       </widget>
-      </item>
-      <item row="1" column="1">
        <widget class="QLabel" name="label_20">
         <property name="text">
@@ -312,5 +517,5 @@
        </widget>
       </item>
-      <item row="0" column="1">
+      <item row="0" column="2">
        <widget class="QLabel" name="label_21">
         <property name="text">
@@ -322,5 +527,5 @@
        </widget>
       </item>
-      <item row="2" column="1">
+      <item row="2" column="2">
        <widget class="QLabel" name="label_22">
         <property name="text">
@@ -332,5 +537,5 @@
        </widget>
       </item>
-      <item row="3" column="1">
+      <item row="3" column="2">
        <widget class="QLabel" name="label_23">
         <property name="text">
@@ -342,15 +547,15 @@
        </widget>
       </item>
-      <item row="0" column="2">
+      <item row="0" column="3">
        <widget class="QDoubleSpinBox" name="colorRange0">
         <property name="enabled">
-         <bool>false</bool>
-        </property>
-        <property name="decimals">
-         <number>3</number>
-        </property>
-       </widget>
-      </item>
-      <item row="2" column="2">
+         <bool>true</bool>
+        </property>
+        <property name="decimals">
+         <number>3</number>
+        </property>
+       </widget>
+      </item>
+      <item row="2" column="3">
        <widget class="QDoubleSpinBox" name="greenValue0">
         <property name="decimals">
@@ -359,5 +564,5 @@
        </widget>
       </item>
-      <item row="3" column="2">
+      <item row="3" column="3">
        <widget class="QDoubleSpinBox" name="blueValue0">
         <property name="decimals">
@@ -366,5 +571,5 @@
        </widget>
       </item>
-      <item row="0" column="3">
+      <item row="0" column="4">
        <widget class="QDoubleSpinBox" name="colorRange1">
         <property name="decimals">
@@ -373,5 +578,5 @@
        </widget>
       </item>
-      <item row="2" column="3">
+      <item row="2" column="4">
        <widget class="QDoubleSpinBox" name="greenValue1">
         <property name="decimals">
@@ -380,5 +585,5 @@
        </widget>
       </item>
-      <item row="3" column="3">
+      <item row="3" column="4">
        <widget class="QDoubleSpinBox" name="blueValue1">
         <property name="decimals">
@@ -387,5 +592,5 @@
        </widget>
       </item>
-      <item row="0" column="4">
+      <item row="0" column="5">
        <widget class="QDoubleSpinBox" name="colorRange2">
         <property name="decimals">
@@ -394,5 +599,5 @@
        </widget>
       </item>
-      <item row="2" column="4">
+      <item row="2" column="5">
        <widget class="QDoubleSpinBox" name="greenValue2">
         <property name="decimals">
@@ -401,5 +606,5 @@
        </widget>
       </item>
-      <item row="3" column="4">
+      <item row="3" column="5">
        <widget class="QDoubleSpinBox" name="blueValue2">
         <property name="decimals">
@@ -408,5 +613,5 @@
        </widget>
       </item>
-      <item row="0" column="5">
+      <item row="0" column="6">
        <widget class="QDoubleSpinBox" name="colorRange3">
         <property name="decimals">
@@ -415,5 +620,5 @@
        </widget>
       </item>
-      <item row="2" column="5">
+      <item row="2" column="6">
        <widget class="QDoubleSpinBox" name="greenValue3">
         <property name="decimals">
@@ -422,5 +627,5 @@
        </widget>
       </item>
-      <item row="3" column="5">
+      <item row="3" column="6">
        <widget class="QDoubleSpinBox" name="blueValue3">
         <property name="decimals">
@@ -429,5 +634,5 @@
        </widget>
       </item>
-      <item row="3" column="7">
+      <item row="3" column="8">
        <layout class="QHBoxLayout" name="horizontalLayout">
         <item>
@@ -443,4 +648,10 @@
         <item>
          <widget class="QDoubleSpinBox" name="slicesPerSecValue">
+          <property name="toolTip">
+           <string>Number of slices to display per seconds</string>
+          </property>
+          <property name="minimum">
+           <double>1.000000000000000</double>
+          </property>
           <property name="maximum">
            <double>1000.000000000000000</double>
@@ -450,5 +661,5 @@
           </property>
           <property name="value">
-           <double>1.000000000000000</double>
+           <double>100.000000000000000</double>
           </property>
          </widget>
@@ -456,5 +667,5 @@
        </layout>
       </item>
-      <item row="1" column="7">
+      <item row="1" column="8">
        <layout class="QHBoxLayout" name="horizontalLayout_4">
         <item>
@@ -467,4 +678,7 @@
         <item>
          <widget class="QPushButton" name="eventsMinusButton">
+          <property name="toolTip">
+           <string>Step backwards in events</string>
+          </property>
           <property name="text">
            <string>-</string>
@@ -474,4 +688,7 @@
         <item>
          <widget class="QSpinBox" name="eventsStepBox">
+          <property name="toolTip">
+           <string>Number of events to skip at each step</string>
+          </property>
           <property name="minimum">
            <number>1</number>
@@ -490,4 +707,7 @@
            </sizepolicy>
           </property>
+          <property name="toolTip">
+           <string>Step forward in events</string>
+          </property>
           <property name="text">
            <string>+</string>
@@ -499,4 +719,7 @@
       <item row="0" column="0">
        <widget class="QCheckBox" name="drawImpulseCheckBox">
+        <property name="toolTip">
+         <string>Whether the impulse of the current pixel should be drawn below the camera or not</string>
+        </property>
         <property name="layoutDirection">
          <enum>Qt::RightToLeft</enum>
@@ -509,4 +732,7 @@
       <item row="3" column="0">
        <widget class="QCheckBox" name="drawBlurCheckBox">
+        <property name="toolTip">
+         <string>Draw the pixels blurred (for having &quot;nice&quot;, non-scientific images).</string>
+        </property>
         <property name="layoutDirection">
          <enum>Qt::RightToLeft</enum>
@@ -519,4 +745,7 @@
       <item row="1" column="0">
        <widget class="QCheckBox" name="drawPatchCheckBox">
+        <property name="toolTip">
+         <string>Whether the pixels clustering should be drawn or not</string>
+        </property>
         <property name="layoutDirection">
          <enum>Qt::RightToLeft</enum>
@@ -525,8 +754,97 @@
          <string>Draw Patches</string>
         </property>
+        <property name="checked">
+         <bool>true</bool>
+        </property>
         <property name="tristate">
          <bool>false</bool>
         </property>
        </widget>
+      </item>
+      <item row="2" column="0">
+       <widget class="QCheckBox" name="loopOverCurrentEventBox">
+        <property name="toolTip">
+         <string>Whether the animation should loop over the current event, or continue to the next event</string>
+        </property>
+        <property name="layoutDirection">
+         <enum>Qt::RightToLeft</enum>
+        </property>
+        <property name="text">
+         <string>Loop event</string>
+        </property>
+       </widget>
+      </item>
+      <item row="1" column="1">
+       <widget class="QPushButton" name="autoScaleColor">
+        <property name="toolTip">
+         <string>Rescale the coloring to match the values of the current event</string>
+        </property>
+        <property name="text">
+         <string>AutoScale !</string>
+        </property>
+       </widget>
+      </item>
+      <item row="2" column="1">
+       <widget class="QRadioButton" name="entireCameraScale">
+        <property name="toolTip">
+         <string>Use the entire camera to do the scaling</string>
+        </property>
+        <property name="layoutDirection">
+         <enum>Qt::RightToLeft</enum>
+        </property>
+        <property name="text">
+         <string>entire camera</string>
+        </property>
+        <property name="checked">
+         <bool>true</bool>
+        </property>
+       </widget>
+      </item>
+      <item row="3" column="1">
+       <widget class="QRadioButton" name="currentPixelScale">
+        <property name="toolTip">
+         <string>Use the current pixel only to do the scaling</string>
+        </property>
+        <property name="layoutDirection">
+         <enum>Qt::RightToLeft</enum>
+        </property>
+        <property name="text">
+         <string>current pixel</string>
+        </property>
+       </widget>
+      </item>
+      <item row="2" column="8">
+       <layout class="QHBoxLayout" name="horizontalLayout_5">
+        <item>
+         <widget class="QPushButton" name="slicesMinusMinusButton">
+          <property name="toolTip">
+           <string>Step backward one slice</string>
+          </property>
+          <property name="text">
+           <string>Slice--</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QPushButton" name="playPauseButton">
+          <property name="toolTip">
+           <string>Play/Pause events animation</string>
+          </property>
+          <property name="text">
+           <string>Play/Pause</string>
+          </property>
+         </widget>
+        </item>
+        <item>
+         <widget class="QPushButton" name="slicesPlusPlusButton">
+          <property name="toolTip">
+           <string>Step forward one slice</string>
+          </property>
+          <property name="text">
+           <string>Slice++</string>
+          </property>
+         </widget>
+        </item>
+       </layout>
       </item>
      </layout>
@@ -536,4 +854,10 @@
  </widget>
  <customwidgets>
+  <customwidget>
+   <class>QwtPlot</class>
+   <extends>QFrame</extends>
+   <header>qwt_plot.h</header>
+   <container>1</container>
+  </customwidget>
   <customwidget>
    <class>QGLWidget</class>